/* loact.h - part of ANSI Terminal Color Handler */
/* Created: Wed 05 Apr 2023 10:27:29 PM EDT malakai */
/* Copyright © 1991-2023 The Last Outpost Project */
/* $Id: loact.h,v 1.1 2023/04/08 02:27:01 malakai Exp $ */

/* Copyright © 2023 Jeff Jahr <malakai@jeffrika.com>
 *
 * This file is part of Locolor - Last Outpost terminal color library
 *
 * Locolor is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * Locolor is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
 * more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Locolor.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef LOACT_H
#define LOACT_H

/* ---- global #defines ----*/

/* ---- structs and typedefs ---- */

/* a typedef for a locolor_act_function */
typedef int lo_actfn_t(GList *args, char *dst, size_t dlen, rgba_context *ctx, void *data);

/* ---- Exported global variable declarations ---- */

/* ---- Exported function declarations ---- */

/* initialization */
void locolor_act_init(int use_builtins);
void locolor_act_quit(void);
void locolor_act_init_builtins(void);
int locolor_act_register(char *name,lo_actfn_t *fn);
int locolor_act_unregister(char *name);

/* locolor_act related functions. */
int locolor_act(char *src, char *dst, size_t dlen, rgba_context *ctx);
void locolor_printf(rgba_context *ctx, char *str, ...);

#endif /* LOACT_H */
